Subject: Re: [PATCH 08/24] net, diet: Make TCP metrics optional

From: Andi Kleen <[email-masked]>
Date: Tue, 6 May 2014 14:05:49 -0700

On Tue, May 06, 2014 at 10:07:38PM +0200, Richard Cochran wrote:
> On Tue, May 06, 2014 at 12:50:49PM -0700, Andi Kleen wrote:
> > 
> > > So I think Dave is right
> > > in rejecting anything that compromises the _quality_ of the stack.
> > 
> > I don't think anything I removed compromised quality (modulo bugs)
> > It's still a more-features-than-your-typical-BSD TCP/IP stack
> 
> But Dave seems to think so.

Appeal to authority?

The vast majority of the patches only remove optional user interfaces.
If the single program running on the embedded system does not use these
interfaces it's simply dead code.

The patches that change non interface parts:

- Make FASTOPEN optional. FASTOPEN is a very expensive feature
because it pulls in the complete crypto subsystem.  It's also
a feature that needs to be explicitely enabled by the user program,
and I doubt is widely deployed
(my work station did exactly zero fast opens ever)
- Make TCP_METRICS optional, so connections don't share state.
- Simplify the routing table for the client < 10 routes case.
Works exactly the same as before with a small number of routes.
- Make GRO optional.
This is purely a performance feature for high bandwidth.

-Andi